diff --git a/game/server/src/main/java/net/minecraft/server/player/PlayerManager.java b/game/server/src/main/java/net/minecraft/server/player/PlayerManager.java
index 74fb5bb81..5db1056dd 100644
--- a/game/server/src/main/java/net/minecraft/server/player/PlayerManager.java
+++ b/game/server/src/main/java/net/minecraft/server/player/PlayerManager.java
@@ -211,7 +211,7 @@ public class PlayerManager
             this.chunkX = chunkX;
             this.chunkZ = chunkZ;
             currentChunk = new ChunkCoordinate(chunkX, chunkZ);
-            server.getDimensionWorld(dimension).chunkProviderServer.prepareChunk(chunkX, chunkZ);
+            server.getDimensionWorld(dimension).getChunkProvider().prepareChunk(chunkX, chunkZ);
         }
 
         public void addPlayer(PlayerServer player) {
@@ -236,7 +236,7 @@ public class PlayerManager
                 if (numBlocksToUpdate > 0) {
                     playerInstancesToUpdate.remove(this);
                 }
-                server.getDimensionWorld(dimension).chunkProviderServer.dropChunk(new ChunkPos(chunkX, chunkZ));
+                server.getDimensionWorld(dimension).getChunkProvider().dropChunk(new ChunkPos(chunkX, chunkZ));
             }
             player.loadedChunks.remove(currentChunk);
             if (player.field_420_ah.contains(currentChunk)) {
diff --git a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
index 7eb8556cb..a8b0efd4d 100644
--- a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
+++ b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
@@ -21,21 +21,21 @@ import net.minecraft.core.world.Explosion;
 import net.minecraft.core.world.ExplosionCannonball;
 import net.minecraft.core.world.SpawnerMobs;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.chunk.IChunkLoader;
-import net.minecraft.core.world.chunk.provider.IChunkProvider;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.chunk.ChunkLoader;
+import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.save.LevelStorage;
-import net.minecraft.core.world.type.WorldType;
+import net.minecraft.core.world.saveddata.SavedDataStorage;
 import net.minecraft.server.MinecraftServer;
 import net.minecraft.server.world.chunk.provider.ChunkProviderServer;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.ArrayList;
 import java.util.List;
 
-public class WorldServer extends World
-{
-    public ChunkProviderServer chunkProviderServer;
+public class WorldServer extends World {
     public boolean dontSave;
     public MinecraftServer mcServer;
     private final Int2ObjectMap<Entity> entityIntHashMap;
@@ -43,37 +43,45 @@ public class WorldServer extends World
 
 
     public WorldServer(
-        MinecraftServer minecraftServer,
-        LevelStorage isavehandler,
-        String name,
-        int dimensionId,
-        long seed
+        final @NotNull MinecraftServer server,
+        final @NotNull LevelStorage levelStorage,
+        final @NotNull String name,
+        final long seed,
+        final @NotNull Dimension dimension
     ) {
-        super(isavehandler, name, seed, Dimension.getDimensionList().get(dimensionId), null);
+        super(levelStorage, name, seed, dimension, null);
 
         entityIntHashMap = new Int2ObjectOpenHashMap<>();
-        mcServer = minecraftServer;
+        mcServer = server;
         getLevelData().setLastPlayerUUID(null);
     }
 
     public WorldServer(
-        MinecraftServer minecraftServer,
-        WorldServer parent,
-        int dimensionId
+        final @NotNull WorldServer parent,
+        final @NotNull Dimension dimension
     ) {
-        super(parent, Dimension.getDimensionList().get(dimensionId));
+        super(parent, dimension);
 
         entityIntHashMap = new Int2ObjectOpenHashMap<>();
-        mcServer = minecraftServer;
+        this.mcServer = parent.mcServer;
         getLevelData().setLastPlayerUUID(null);
     }
 
     @Override
-    protected IChunkProvider createChunkProvider()
+    public void setLightningFlicker(final int flicker) {
+        // Do nothing
+    }
+
+    @Override
+    public @NotNull ChunkProviderServer getChunkProvider() {
+        return (ChunkProviderServer) super.getChunkProvider();
+    }
+
+    @Override
+    protected @NotNull ChunkProviderServer createChunkProvider(final @NotNull LevelStorage levelStorage)
     {
-        IChunkLoader ichunkloader = this.getLevelStorage().getChunkLoader(dimension);
-        this.chunkProviderServer = (ChunkProviderServer) Global.accessor.createChunkProvider(this, ichunkloader);
-        return chunkProviderServer;
+        final @Nullable ChunkLoader chunkLoader = levelStorage.getChunkLoader(dimension);
+        return new ChunkProviderServer(this, chunkLoader, this.getWorldType().createChunkGenerator(this));
     }
 
     public List<TileEntity> getBlockEntitiesWithinBounds(int minX, int minY, int minZ, int maxX, int maxY, int maxZ)
@@ -94,8 +102,8 @@ public class WorldServer extends World
     @Override
     public boolean canMineBlock(final @NotNull Player player, final @NotNull TilePosc tilePos) {
         if (this.mcServer.spawnProtectionRange <= 0 || this.mcServer.playerList.isOp(player.uuid)) return super.canMineBlock(player, tilePos);
-        final int dx = (int)MathHelper.abs(tilePos.x() - this.getLevelData().getSpawnX());
-        final int dz = (int)MathHelper.abs(tilePos.z() - this.getLevelData().getSpawnZ());
+        final int dx = (int)MathHelper.abs(tilePos.x() - this.getLevelData().getSpawnPos().x());
+        final int dz = (int)MathHelper.abs(tilePos.z() - this.getLevelData().getSpawnPos().z());
         return Math.max(dx, dz) > this.mcServer.spawnProtectionRange;
     }
 
@@ -141,7 +149,7 @@ public class WorldServer extends World
                 }
 
                 long timePlusOneDay = getLevelData().getWorldTime() + Global.DAY_LENGTH_TICKS;
-                getLevelData().setWorldTime(timePlusOneDay - timePlusOneDay % Global.DAY_LENGTH_TICKS + worldType.getSunriseTick(this) + Global.DAY_LENGTH_TICKS / 24);
+                getLevelData().setWorldTime(timePlusOneDay - timePlusOneDay % Global.DAY_LENGTH_TICKS + getWorldType().getSunriseTick(this) + Global.DAY_LENGTH_TICKS / 24);
                 wakeUpAllPlayers();
             }
         }
diff --git a/game/server/src/main/java/net/minecraft/server/world/chunk/provider/ChunkProviderServer.java b/game/server/src/main/java/net/minecraft/server/world/chunk/provider/ChunkProviderServer.java
index 48d08d675..5652e2676 100644
--- a/game/server/src/main/java/net/minecraft/server/world/chunk/provider/ChunkProviderServer.java
+++ b/game/server/src/main/java/net/minecraft/server/world/chunk/provider/ChunkProviderServer.java
@@ -2,8 +2,9 @@ package net.minecraft.server.world.chunk.provider;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.core.world.ProgressListener;
-import net.minecraft.core.world.chunk.provider.IChunkProvider;
+import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.pos.ChunkPos;
+import net.minecraft.core.world.pos.ChunkPosc;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.server.world.WorldServer;
 import net.minecraft.core.world.chunk.*;
@@ -16,18 +17,18 @@ import java.io.IOException;
 import java.util.*;
 
 public class ChunkProviderServer
-    implements IChunkProvider {
+    implements ChunkProvider {
     private static final Logger LOGGER = LogUtils.getLogger();
     private final Set<ChunkPos> droppedChunksSet;
     private final Chunk emptyChunk;
     public ChunkGenerator chunkGenerator;
-    private final IChunkLoader chunkLoader;
+    private final ChunkLoader chunkLoader;
     public boolean chunkLoadOverride;
     private final Map<ChunkPos, Chunk> chunkMap;
     private final List<Chunk> chunkList;
     private final WorldServer world;
 
-    public ChunkProviderServer(WorldServer world, IChunkLoader chunkLoader, ChunkGenerator chunkGenerator) {
+    public ChunkProviderServer(WorldServer world, ChunkLoader chunkLoader, ChunkGenerator chunkGenerator) {
         this.droppedChunksSet = new HashSet<>();
         this.chunkLoadOverride = false;
         this.chunkMap = new HashMap<>();
@@ -39,7 +40,7 @@ public class ChunkProviderServer
     }
 
     @Override
-    public boolean isChunkLoaded(@NotNull ChunkPos chunkPos) {
+    public boolean isChunkLoaded(@NotNull ChunkPosc chunkPos) {
         return this.chunkMap.containsKey(chunkPos);
     }
 
@@ -55,14 +56,14 @@ public class ChunkProviderServer
     }
 
     @Override
-    public @NotNull Chunk prepareChunk(@NotNull ChunkPos chunkPos, boolean priority) {
+    public @NotNull Chunk prepareChunk(@NotNull ChunkPosc chunkPos, boolean priority) {
         this.droppedChunksSet.remove(chunkPos);
         Chunk chunk = this.chunkMap.get(chunkPos);
         if (chunk == null) {
             chunk = loadChunkFromFile(chunkPos);
             if (chunk == null) {
                 if (this.chunkGenerator != null) {
-                    chunk = this.chunkGenerator.generate(chunkPos.x, chunkPos.z);
+                    chunk = this.chunkGenerator.generate(chunkPos.x(), chunkPos.z());
                     chunk.fixMissingBlocks();
                 } else {
                     chunk = this.emptyChunk;
@@ -72,17 +73,35 @@ public class ChunkProviderServer
             this.chunkList.add(chunk);
             chunk.checkForLightGaps();
             chunk.onLoad();
-            if (!chunk.isTerrainPopulated && isChunkLoaded(chunkPos.x + 1, chunkPos.z + 1) && isChunkLoaded(chunkPos.x, chunkPos.z + 1) && isChunkLoaded(chunkPos.x + 1, chunkPos.z)) {
-                populate(this, chunkPos.x, chunkPos.z);
+            final @NotNull ChunkPos queryPos = new ChunkPos(chunkPos);
+            if (
+                !chunk.isTerrainPopulated &&
+                    isChunkLoaded(chunkPos.add(1, 1, queryPos)) &&
+                    isChunkLoaded(chunkPos.add(0, 1, queryPos)) &&
+                    isChunkLoaded(chunkPos.add(1, 0, queryPos))
+            ) {
+                populate(chunkPos);
             }
-            if (isChunkLoaded(chunkPos.x - 1, chunkPos.z) && !provideChunk(chunkPos.x - 1, chunkPos.z).isTerrainPopulated && isChunkLoaded(chunkPos.x - 1, chunkPos.z + 1) && isChunkLoaded(chunkPos.x, chunkPos.z + 1) && isChunkLoaded(chunkPos.x - 1, chunkPos.z)) {
-                populate(this, chunkPos.x - 1, chunkPos.z);
+            if (
+                isChunkLoaded(chunkPos.add(-1, 0, queryPos)) && !provideChunk(chunkPos.add(-1, 0, queryPos), true).isTerrainPopulated &&
+                    isChunkLoaded(chunkPos.add(-1, 1, queryPos)) &&
+                    isChunkLoaded(chunkPos.add(0, 1, queryPos))
+            ) {
+                populate(chunkPos.add(-1, 0, queryPos));
             }
-            if (isChunkLoaded(chunkPos.x, chunkPos.z - 1) && !provideChunk(chunkPos.x, chunkPos.z - 1).isTerrainPopulated && isChunkLoaded(chunkPos.x + 1, chunkPos.z - 1) && isChunkLoaded(chunkPos.x, chunkPos.z - 1) && isChunkLoaded(chunkPos.x + 1, chunkPos.z)) {
-                populate(this, chunkPos.x, chunkPos.z - 1);
+            if (
+                isChunkLoaded(chunkPos.add(0, -1, queryPos)) && !provideChunk(chunkPos.add(0, -1, queryPos), true).isTerrainPopulated &&
+                    isChunkLoaded(chunkPos.add(1, -1, queryPos)) &&
+                    isChunkLoaded(chunkPos.add(1, 0, queryPos))
+            ) {
+                populate(chunkPos.add(0, -1, queryPos));
             }
-            if (isChunkLoaded(chunkPos.x - 1, chunkPos.z - 1) && !provideChunk(chunkPos.x - 1, chunkPos.z - 1).isTerrainPopulated && isChunkLoaded(chunkPos.x - 1, chunkPos.z - 1) && isChunkLoaded(chunkPos.x, chunkPos.z - 1) && isChunkLoaded(chunkPos.x - 1, chunkPos.z)) {
-                populate(this, chunkPos.x - 1, chunkPos.z - 1);
+            if (
+                isChunkLoaded(chunkPos.add(-1, -1, queryPos)) && !provideChunk(chunkPos.add(-1, -1, queryPos), true).isTerrainPopulated &&
+                    isChunkLoaded(chunkPos.add(0, -1, queryPos)) &&
+                    isChunkLoaded(chunkPos.add(-1, 0, queryPos))
+            ) {
+                populate(chunkPos.add(-1, -1, queryPos));
             }
             if (this.world.getCurrentWeather() != null) {
                 this.world.getCurrentWeather().doChunkLoadEffect(this.world, chunk);
@@ -92,34 +111,52 @@ public class ChunkProviderServer
     }
 
     @Override
-    public void regenerateChunk(@NotNull ChunkPos chunkPos) {
+    public void regenerateChunk(@NotNull ChunkPosc chunkPos) {
         this.droppedChunksSet.remove(chunkPos);
         this.chunkList.remove(this.chunkMap.get(chunkPos));
         this.chunkMap.remove(chunkPos);
         Chunk chunk;
         if (this.chunkGenerator != null) {
-            chunk = this.chunkGenerator.generate(chunkPos.x, chunkPos.z);
+            chunk = this.chunkGenerator.generate(chunkPos.x(), chunkPos.z());
             chunk.fixMissingBlocks();
         } else {
             return;
         }
         this.chunkMap.put(new ChunkPos(chunkPos), chunk);
-        if (!chunk.isTerrainPopulated && isChunkLoaded(chunkPos.x + 1, chunkPos.z + 1) && isChunkLoaded(chunkPos.x, chunkPos.z + 1) && isChunkLoaded(chunkPos.x + 1, chunkPos.z)) {
-            populate(new ChunkPos(chunkPos.x, chunkPos.z));
+        final @NotNull ChunkPos queryPos = new ChunkPos(chunkPos);
+        if (
+            !chunk.isTerrainPopulated &&
+                isChunkLoaded(chunkPos.add(1, 1, queryPos)) &&
+                isChunkLoaded(chunkPos.add(0, 1, queryPos)) &&
+                isChunkLoaded(chunkPos.add(1, 0, queryPos))
+        ) {
+            populate(chunkPos);
         }
-        if (isChunkLoaded(chunkPos.x - 1, chunkPos.z) && !provideChunk(chunkPos.x - 1, chunkPos.z).isTerrainPopulated && isChunkLoaded(chunkPos.x - 1, chunkPos.z + 1) && isChunkLoaded(chunkPos.x, chunkPos.z + 1) && isChunkLoaded(chunkPos.x - 1, chunkPos.z)) {
-            populate(new ChunkPos(chunkPos.x - 1, chunkPos.z));
+        if (
+            isChunkLoaded(chunkPos.add(-1, 0, queryPos)) && !provideChunk(chunkPos.add(-1, 0, queryPos), true).isTerrainPopulated &&
+                isChunkLoaded(chunkPos.add(-1, 1, queryPos)) &&
+                isChunkLoaded(chunkPos.add(0, 1, queryPos))
+        ) {
+            populate(chunkPos.add(-1, 0, queryPos));
         }
-        if (isChunkLoaded(chunkPos.x, chunkPos.z - 1) && !provideChunk(chunkPos.x, chunkPos.z - 1).isTerrainPopulated && isChunkLoaded(chunkPos.x + 1, chunkPos.z - 1) && isChunkLoaded(chunkPos.x, chunkPos.z - 1) && isChunkLoaded(chunkPos.x + 1, chunkPos.z)) {
-            populate(new ChunkPos(chunkPos.x, chunkPos.z - 1));
+        if (
+            isChunkLoaded(chunkPos.add(0, -1, queryPos)) && !provideChunk(chunkPos.add(0, -1, queryPos), true).isTerrainPopulated &&
+                isChunkLoaded(chunkPos.add(1, -1, queryPos)) &&
+                isChunkLoaded(chunkPos.add(1, 0, queryPos))
+        ) {
+            populate(chunkPos.add(0, -1, queryPos));
         }
-        if (isChunkLoaded(chunkPos.x - 1, chunkPos.z - 1) && !provideChunk(chunkPos.x - 1, chunkPos.z - 1).isTerrainPopulated && isChunkLoaded(chunkPos.x - 1, chunkPos.z - 1) && isChunkLoaded(chunkPos.x, chunkPos.z - 1) && isChunkLoaded(chunkPos.x - 1, chunkPos.z)) {
-            populate(new ChunkPos(chunkPos.x - 1, chunkPos.z - 1));
+        if (
+            isChunkLoaded(chunkPos.add(-1, -1, queryPos)) && !provideChunk(chunkPos.add(-1, -1, queryPos), true).isTerrainPopulated &&
+                isChunkLoaded(chunkPos.add(0, -1, queryPos)) &&
+                isChunkLoaded(chunkPos.add(-1, 0, queryPos))
+        ) {
+            populate(chunkPos.add(-1, -1, queryPos));
         }
     }
 
     @Override
-    public @NotNull Chunk provideChunk(@NotNull ChunkPos chunkPos, boolean priority) {
+    public @NotNull Chunk provideChunk(@NotNull ChunkPosc chunkPos, boolean priority) {
         Chunk chunk = this.chunkMap.get(chunkPos);
         if (chunk == null) {
             if (this.world.findingSpawnPoint || this.chunkLoadOverride) {
@@ -132,18 +169,18 @@ public class ChunkProviderServer
         }
     }
 
-    private Chunk loadChunkFromFile(@NotNull ChunkPos chunkPos) {
+    private @Nullable Chunk loadChunkFromFile(@NotNull ChunkPosc chunkPos) {
         if (this.chunkLoader == null) {
             return null;
         }
         try {
-            Chunk chunk = this.chunkLoader.loadChunk(this.world, chunkPos.x, chunkPos.z);
+            Chunk chunk = this.chunkLoader.loadChunk(this.world, chunkPos.x(), chunkPos.z());
             if (chunk != null) {
                 chunk.lastSaveTime = this.world.getWorldTime();
             }
             return chunk;
         } catch (Exception exception) {
-            LOGGER.error("Failed to load chunk at X:{}, Z:{} to disk!", chunkPos.x, chunkPos.z, exception);
+            LOGGER.error("Failed to load chunk at X:{}, Z:{} to disk!", chunkPos.x(), chunkPos.z(), exception);
         }
         return null;
     }
@@ -161,7 +198,7 @@ public class ChunkProviderServer
     }
 
     @Override
-    public void populate(@NotNull ChunkPos chunkPos) {
+    public void populate(@NotNull ChunkPosc chunkPos) {
         Chunk chunk = provideChunk(chunkPos, true);
         if (!chunk.isTerrainPopulated) {
             chunk.isTerrainPopulated = true;
@@ -228,7 +265,7 @@ public class ChunkProviderServer
     }
 
     @Override
-    public void setCurrentChunkOver(@NotNull ChunkPos chunkPos) {
+    public void setCurrentChunkOver(@NotNull ChunkPosc chunkPos) {
         // Do nothing
     }
 }
diff --git a/util/nbt/src/main/java/com/mojang/nbt/tags/CompoundTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/CompoundTag.java
index 11008e673..6eaae0cf6 100644
--- a/util/nbt/src/main/java/com/mojang/nbt/tags/CompoundTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/CompoundTag.java
@@ -4,6 +4,7 @@ import com.google.gson.JsonElement;
 import com.google.gson.JsonObject;
 import com.google.gson.JsonParseException;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.io.*;
 import java.util.*;
@@ -248,12 +249,12 @@ public class CompoundTag extends Tag<@NotNull Map<String, Tag<?>>>
         put(key, new DoubleTag(value));
     }
 
-    public String getString(String key)
+    public @NotNull String getString(String key)
     {
         return getStringOrDefault(key, "");
     }
 
-    public String getStringOrDefault(String key, String defaultValue)
+    public @Nullable String getStringOrDefault(final @NotNull String key, final @Nullable String defaultValue)
     {
         Tag<?> tag = getTagOrDefault(key, null);
 
@@ -353,12 +354,12 @@ public class CompoundTag extends Tag<@NotNull Map<String, Tag<?>>>
         put(key, new LongArrayTag(array));
     }
 
-    public CompoundTag getCompound(String key)
+    public @NotNull CompoundTag getCompound(@NotNull String key)
     {
         return getCompoundOrDefault(key, new CompoundTag());
     }
 
-    public CompoundTag getCompoundOrDefault(String key, CompoundTag defaultCompound)
+    public @Nullable CompoundTag getCompoundOrDefault(@NotNull String key, @Nullable CompoundTag defaultCompound)
     {
         Tag<?> tag = getTagOrDefault(key, null);
 
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAChunkProvider.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAChunkProvider.java
index 50f0fbfca..78fcbab91 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAChunkProvider.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTAChunkProvider.java
@@ -6,6 +6,7 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
 import net.minecraft.core.world.biome.provider.BiomeProviderOverworld;
@@ -45,7 +46,7 @@ public class BTAChunkProvider implements ChunkProvider {
 
     public BTAChunkProvider(File worldFolder, LevelData data) {
         this.biomeProvider = new BiomeProviderOverworld(data.getRandomSeed(), WorldTypes.OVERWORLD_EXTENDED);
-        this.chunkLoader = new ChunkLoader(worldFolder, 0);
+        this.chunkLoader = new ChunkLoader(worldFolder, Dimension.OVERWORLD);
     }
     @Override
     public ViewerChunk getChunk(ChunkPos location) {
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/DummyMinecraft.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/DummyMinecraft.java
index a1eb4446b..1c3e89ab3 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/DummyMinecraft.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/DummyMinecraft.java
@@ -3,8 +3,8 @@ package org.useless.seedviewer.bta;
 import net.minecraft.core.MinecraftAccessor;
 import net.minecraft.core.entity.SkinVariantList;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.chunk.IChunkLoader;
-import net.minecraft.core.world.chunk.provider.IChunkProvider;
+import net.minecraft.core.world.chunk.ChunkLoader;
+import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import org.useless.seedviewer.bta.chunk.provider.ChunkProviderSeedViewer;
 
 import java.io.File;
@@ -14,7 +14,7 @@ public class DummyMinecraft implements MinecraftAccessor {
         return getAppDir("minecraft-bta");
     }
 
-    public IChunkProvider createChunkProvider(World world, IChunkLoader chunkLoader) {
+    public ChunkProvider createChunkProvider(World world, ChunkLoader chunkLoader) {
         return new ChunkProviderSeedViewer(world, chunkLoader, world.getWorldType().createChunkGenerator(world));
     }
 
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/DummyWorld.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/DummyWorld.java
new file mode 100644
index 000000000..62c0f422b
--- /dev/null
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/DummyWorld.java
@@ -0,0 +1,34 @@
+package org.useless.seedviewer.bta;
+
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.chunk.provider.ChunkProvider;
+import net.minecraft.core.world.save.LevelStorage;
+import net.minecraft.core.world.save.LevelStorageDummy;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.seedviewer.bta.worldloader.ChunkLoader;
+
+import java.lang.reflect.Field;
+import java.util.Objects;
+
+public class DummyWorld extends World {
+    public static @Nullable ChunkLoader CHUNK_LOADER = null;
+
+    public DummyWorld(
+        final @NotNull Dimension dimension
+    ) {
+        super(new LevelStorageDummy(), "Dummy World", 0, dimension, null);
+    }
+
+    @Override
+    public void setLightningFlicker(final int flicker) {
+        // Do nothing
+    }
+
+    @Override
+    protected @NotNull ChunkProvider createChunkProvider(final @NotNull LevelStorage levelStorage) {
+        return Objects.requireNonNull(CHUNK_LOADER);
+    }
+}
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/chunk/provider/ChunkProviderSeedViewer.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/chunk/provider/ChunkProviderSeedViewer.java
index d94f0c391..027111c4b 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/chunk/provider/ChunkProviderSeedViewer.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/chunk/provider/ChunkProviderSeedViewer.java
@@ -5,10 +5,11 @@ import net.minecraft.core.world.ProgressListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.EmptyChunk;
-import net.minecraft.core.world.chunk.IChunkLoader;
-import net.minecraft.core.world.chunk.provider.IChunkProvider;
+import net.minecraft.core.world.chunk.ChunkLoader;
+import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.pos.ChunkPos;
+import net.minecraft.core.world.pos.ChunkPosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
@@ -16,14 +17,14 @@ import org.slf4j.Logger;
 import java.util.Arrays;
 
 public class ChunkProviderSeedViewer
-    implements IChunkProvider {
+    implements ChunkProvider {
     public static final int CHUNK_RADIUS = 64; // Radius should *always* be a power of 2!
     public static final int CHUNK_MASK = CHUNK_RADIUS * 2 - 1;
 
     private static final Logger LOGGER = LogUtils.getLogger();
     private final @NotNull Chunk blankChunk;
     public @Nullable ChunkGenerator chunkGenerator;
-    private final @Nullable IChunkLoader chunkLoader;
+    private final @Nullable ChunkLoader chunkLoader;
     private final Chunk[] chunks;
     private final @NotNull World world;
     private @NotNull ChunkPos lastQueriedChunkPos = new ChunkPos(Integer.MIN_VALUE, Integer.MIN_VALUE);
@@ -31,7 +32,7 @@ public class ChunkProviderSeedViewer
     private @NotNull ChunkPos curChunkPos = new ChunkPos(0, 0);
 
 
-    public ChunkProviderSeedViewer(@NotNull World world, @Nullable IChunkLoader ichunkloader, @Nullable ChunkGenerator chunkGenerator) {
+    public ChunkProviderSeedViewer(@NotNull World world, @Nullable ChunkLoader ichunkloader, @Nullable ChunkGenerator chunkGenerator) {
         this.chunks = new Chunk[CHUNK_RADIUS * 2 * CHUNK_RADIUS * 2];
         this.blankChunk = new EmptyChunk(world, new ChunkPos(0, 0));
         this.world = world;
@@ -41,23 +42,23 @@ public class ChunkProviderSeedViewer
     }
 
     @Override
-    public void setCurrentChunkOver(@NotNull ChunkPos chunkPos) {
+    public void setCurrentChunkOver(@NotNull ChunkPosc chunkPos) {
         this.curChunkPos = new ChunkPos(chunkPos);
     }
 
-    public boolean canChunkExist(@NotNull ChunkPos chunkPos) {
+    public boolean canChunkExist(@NotNull ChunkPosc chunkPos) {
         byte r = CHUNK_RADIUS - 1;
-        return chunkPos.x >= this.curChunkPos.x - r && chunkPos.z >= this.curChunkPos.z - r && chunkPos.x <= this.curChunkPos.x + r && chunkPos.z <= this.curChunkPos.z + r;
+        return chunkPos.x() >= this.curChunkPos.x - r && chunkPos.z() >= this.curChunkPos.z - r && chunkPos.x() <= this.curChunkPos.x + r && chunkPos.z() <= this.curChunkPos.z + r;
     }
 
     @Override
-    public void regenerateChunk(@NotNull ChunkPos chunkPos) {
-        int cx = chunkPos.x & CHUNK_MASK;
-        int cz = chunkPos.z & CHUNK_MASK;
+    public void regenerateChunk(@NotNull ChunkPosc chunkPos) {
+        int cx = chunkPos.x() & CHUNK_MASK;
+        int cz = chunkPos.z() & CHUNK_MASK;
         int index = cx + cz * CHUNK_RADIUS * 2;
         Chunk newChunk;
         if (this.chunkGenerator != null) {
-            newChunk = this.chunkGenerator.generate(chunkPos.x, chunkPos.z);
+            newChunk = this.chunkGenerator.generate(chunkPos.x(), chunkPos.z());
             newChunk.fixMissingBlocks();
         } else {
             return;
@@ -79,35 +80,35 @@ public class ChunkProviderSeedViewer
     }
 
     @Override
-    public boolean isChunkLoaded(@NotNull ChunkPos chunkPos) {
+    public boolean isChunkLoaded(@NotNull ChunkPosc chunkPos) {
         if (!canChunkExist(chunkPos)) {
             return false;
         }
         if (chunkPos.equals(this.lastQueriedChunkPos) && this.lastQueriedChunk != null) {
             return true;
         } else {
-            int k = chunkPos.x & CHUNK_MASK;
-            int l = chunkPos.z & CHUNK_MASK;
+            int k = chunkPos.x() & CHUNK_MASK;
+            int l = chunkPos.z() & CHUNK_MASK;
             int chunkIndex = k + l * CHUNK_RADIUS * 2;
             return this.chunks[chunkIndex] == this.blankChunk || (this.chunks[chunkIndex] != null && this.chunks[chunkIndex].isAtLocation(chunkPos));
         }
     }
 
     @Override
-    public @NotNull Chunk prepareChunk(@NotNull ChunkPos chunkPos, boolean priority) {
+    public @NotNull Chunk prepareChunk(@NotNull ChunkPosc chunkPos, boolean priority) {
         return provideChunk(chunkPos, true);
     }
 
     @Override
-    public @NotNull Chunk provideChunk(@NotNull ChunkPos chunkPos, boolean priority) {
+    public @NotNull Chunk provideChunk(@NotNull ChunkPosc chunkPos, boolean priority) {
         if (chunkPos.equals(this.lastQueriedChunkPos) && this.lastQueriedChunk != null) {
             return this.lastQueriedChunk;
         }
         if (!this.world.findingSpawnPoint && !canChunkExist(chunkPos)) {
             return this.blankChunk;
         }
-        int cx = chunkPos.x & CHUNK_MASK;
-        int cz = chunkPos.z & CHUNK_MASK;
+        int cx = chunkPos.x() & CHUNK_MASK;
+        int cz = chunkPos.z() & CHUNK_MASK;
         int index = cx + cz * CHUNK_RADIUS * 2;
         if (!isChunkLoaded(chunkPos)) {
             if (this.chunks[index] != null) {
@@ -116,7 +117,7 @@ public class ChunkProviderSeedViewer
             Chunk chunk = loadChunk(chunkPos);
             if (chunk == null) {
                 if (this.chunkGenerator != null) {
-                    chunk = this.chunkGenerator.generate(chunkPos.x, chunkPos.z);
+                    chunk = this.chunkGenerator.generate(chunkPos.x(), chunkPos.z());
                     chunk.fixMissingBlocks();
                 } else {
                     chunk = this.blankChunk;
@@ -142,29 +143,29 @@ public class ChunkProviderSeedViewer
                 this.world.getCurrentWeather().doChunkLoadEffect(this.world, chunk);
             }
         }
-        this.lastQueriedChunkPos = chunkPos;
+        this.lastQueriedChunkPos = new ChunkPos(chunkPos);
         this.lastQueriedChunk = this.chunks[index];
         return this.chunks[index];
     }
 
-    private Chunk loadChunk(@NotNull ChunkPos chunkPos) {
+    private Chunk loadChunk(@NotNull ChunkPosc chunkPos) {
         if (this.chunkLoader == null) {
             return this.blankChunk;
         }
         try {
-            Chunk chunk = this.chunkLoader.loadChunk(this.world, chunkPos.x, chunkPos.z);
+            Chunk chunk = this.chunkLoader.loadChunk(this.world, chunkPos.x(), chunkPos.z());
             if (chunk != null) {
                 chunk.lastSaveTime = this.world.getWorldTime();
             }
             return chunk;
         } catch (Exception exception) {
-            LOGGER.error("Error loading chunk at X:{}, Z:{}", chunkPos.x, chunkPos.x, exception);
+            LOGGER.error("Error loading chunk at X:{}, Z:{}", chunkPos.x(), chunkPos.x(), exception);
         }
         return this.blankChunk;
     }
 
     @Override
-    public void populate(@NotNull ChunkPos chunkPos) {
+    public void populate(@NotNull ChunkPosc chunkPos) {
 
     }
 
